# filesink

Write incoming data to a file in the local file system.

## Example launch line

     gst-launch-1.0 v4l2src num-buffers=1 ! jpegenc ! filesink location=capture1.jpeg

Capture one frame from a v4l2 camera and save as jpeg image.

## Hierarchy

    GObject
        ╰──GInitiallyUnowned
            ╰──GstObject
                ╰──GstElement
                    ╰──GstBaseSink
                        ╰──filesink

## Implemented interfaces

    GstURIHandler

## Factory details

Authors: – Thomas Vander Stichele <thomas at apestaart dot org></thomas>

Classification: – `Sink/File`

Rank – primary

Plugin – coreelements

Package – GStreamer

## Pad Templates

### `sink`

    ANY

Presence – always

Direction – sink

Object type – GstPad

## Properties

### append

    “append” gboolean

Append to an already existing file.

Flags : Read / Write

Default value : false

### buffer-mode

    “buffer-mode” File-sink-buffer-mode *

The buffering mode to use

Flags : Read / Write

Default value : default (-1)

### buffer-size

    “buffer-size” guint

Size of buffer in number of bytes for line or full buffer-mode

Flags : Read / Write

Default value : 65536

### file-mode

    “file-mode” File-sink-file-mode *

Ability to specify file mode.

Flags : Read / Write

Default value : truncate (1)

Since : 1.24

### location

    “location” gchararray

Location of the file to write

Flags : Read / Write

Default value : NULL

### max-transient-error-timeout

    “max-transient-error-timeout” gint

Retry up to this many ms on transient errors (currently EACCES)

Flags : Read / Write

Default value : 0

### o-sync

    “o-sync” gboolean

Open the file with O_SYNC for enabling synchronous IO

Flags : Read / Write

Default value : false

## Named constants

### File-sink-buffer-mode

File read buffering mode.

#### Members

`default` (-1) – Default buffering
`full` (0) – Fully buffered
`line` (1) – Line buffered (deprecated, like full)
`unbuffered` (2) – Unbuffered

### File-sink-file-mode

File write mode.

#### Members

`truncate` (1) – Truncate file (mode wb)
`output` (2) – Append file (mode ab)
`overwrite` (3) – Overwrite file without truncating (mode rb+)

Since : 1.24

The results of the search are